unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, OleCtrls, HelpUnit, VAXSIPUSERAGENTOCXLib_TLB,
  ExtCtrls, MMSystem;

type
   TMainForm = class(TForm)
    GroupBox1: TGroupBox;
    EditLoginId: TEdit;
    EditLoginPwd: TEdit;
    EditSIPProxy: TEdit;
    EditOutboundProxy: TEdit;
    
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    BtnInit: TButton;
    EditPhoneNo: TEdit;
    BtnDial1: TButton;
    BtnDial2: TButton;
    BtnDial3: TButton;
    BtnDial4: TButton;
    BtnDial5: TButton;
    BtnDial6: TButton;
    BtnDial7: TButton;
    BtnDial8: TButton;
    BtnDial9: TButton;
    BtnDialStar: TButton;
    BtnDial0: TButton;
    BtnDialNo: TButton;
    GroupBox2: TGroupBox;
    BtnAcceptCall: TButton;
    BtnDial: TButton;
    BtnHangUp: TButton;
    GroupBoxVolume: TGroupBox;
    LabelSpeaker: TLabel;
    Label5: TLabel;
    TrackBarSpkVol: TTrackBar;
    CheckBoxSpkMute: TCheckBox;
    GroupBoxLine: TGroupBox;
    CheckBoxMuteMic: TCheckBox;
    TrackBarMicVol: TTrackBar;
    GroupBox3: TGroupBox;
    BtnRejectCall: TButton;
    GroupBox4: TGroupBox;
    Label7: TLabel;
    Label8: TLabel;
    GroupBox5: TGroupBox;
    GroupBox6: TGroupBox;
    GroupBox7: TGroupBox;
    Label10: TLabel;
    CheckBoxStartRecording: TCheckBox;
    BtnResetBuffer: TButton;
    BtnSave: TButton;
    EditRecordFileName: TEdit;
    CheckEchoCancel: TCheckBox;
    CheckMicBoost: TCheckBox;
    CheckDonotDisturb: TCheckBox;
    CheckGSM610: TCheckBox;
    CheckiLBC: TCheckBox;
    CheckG711A: TCheckBox;
    CheckG711U: TCheckBox;
    EditTotalLines: TEdit;
    Label11: TLabel;
    CheckBoxEnableSoundDevice: TCheckBox;
    ComboBoxDial: TComboBox;
    Label12: TLabel;
    BtnHold: TButton;
    BtnUnhold: TButton;
    ListBoxIncomingCall: TListBox;
    Label13: TLabel;
    ComboBoxIncomingCall: TComboBox;
    CheckBoxRingTone: TCheckBox;
    ListBoxIcomingCallId: TListBox;
    Label14: TLabel;
    ComboBoxRecord: TComboBox;
    GroupBox8: TGroupBox;
    Label15: TLabel;
    Label16: TLabel;
    CheckBoxPlayListen: TCheckBox;
    BtnPlayWaveStart: TButton;
    BtnOpenPlayWave: TButton;
    EditPlayFileName: TEdit;
    ComboBoxPlayWave: TComboBox;
    BtnPlayWaveRewind: TButton;
    BtnPlayWaveForward: TButton;
    BtnPlayWavePause: TButton;
    BtnPlayWaveStop: TButton;
    BtnMoreHelp: TButton;
    CheckBoxAGC: TCheckBox;
    GroupBox9: TGroupBox;
    Label9: TLabel;
    Label17: TLabel;
    BtnTransferCall: TButton;
    EditTransferNo: TEdit;
    ComboBoxTransferCall: TComboBox;
    GroupBox10: TGroupBox;
    ListStatusLog: TListBox;
    Button10: TButton;
    TimerTick: TTimer;
    SpkProgBar: TProgressBar;
    MicProgBar: TProgressBar;
    Label6: TLabel;
    Label18: TLabel;
    TimerProgress: TTimer;
    Label19: TLabel;
    EditDisplayName: TEdit;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    ListViewLineStatus: TListView;
    CheckBoxRegisterToProxy: TCheckBox;
    GroupBox11: TGroupBox;
    GroupBox12: TGroupBox;
    ListAudioOut: TListBox;
    ListAudioIn: TListBox;
    VaxSIPUserAgentOCX: TVaxSIPUserAgentOCX;
    function InitVaxObject() : WordBool;
    function OpenLines() : WordBool;
    procedure FillComboBoxes();
    procedure ErrorMessages();
    procedure TrackBarSpkVolChange(Sender: TObject);
    procedure TrackBarMicVolChange(Sender: TObject);
    procedure BtnInitClick(Sender: TObject);
    procedure BtnDial1Click(Sender: TObject);
    procedure BtnDial2Click(Sender: TObject);
    procedure BtnDial3Click(Sender: TObject);
    procedure BtnDial4Click(Sender: TObject);
    procedure BtnDial5Click(Sender: TObject);
    procedure BtnDial6Click(Sender: TObject);
    procedure BtnDial7Click(Sender: TObject);
    procedure BtnDial8Click(Sender: TObject);
    procedure BtnDial9Click(Sender: TObject);
    procedure BtnDialStarClick(Sender: TObject);
    procedure BtnDial0Click(Sender: TObject);
    procedure BtnDialNoClick(Sender: TObject);
    procedure BtnDialClick(Sender: TObject);
    procedure BtnHangUpClick(Sender: TObject);
    procedure BtnAcceptCallClick(Sender: TObject);
    procedure BtnRejectCallClick(Sender: TObject);
    procedure BtnClearClick(Sender: TObject);
    procedure BtnSaveClick(Sender: TObject);
    procedure CheckBoxStartRecordingClick(Sender: TObject);
    procedure BtnResetBufferClick(Sender: TObject);
    procedure CheckBoxSpkMuteClick(Sender: TObject);
    procedure CheckBoxMuteMicClick(Sender: TObject);
    procedure AddToStatusLog(LogText : String);
    function GetCodecName(CodecNo : Integer) : String;

    procedure UpdateListAudioIn();
    procedure UpdateListAudioOut();

    function GetSelectedAudioOut() : Integer;
    function GetSelectedAudioIn()  : Integer;
    
    procedure VaxSIPUserAgentOCXFailToRegister(Sender: TObject);
    procedure VaxSIPUserAgentOCXFailToUnRegister(Sender: TObject);
    procedure VaxSIPUserAgentOCXSuccessToUnRegister(Sender: TObject);

    procedure CheckEchoCancelClick(Sender: TObject);
    procedure CheckMicBoostClick(Sender: TObject);
    procedure CheckDonotDisturbClick(Sender: TObject);
    procedure CheckGSM610Click(Sender: TObject);
    procedure CheckiLBCClick(Sender: TObject);
    procedure CheckG711AClick(Sender: TObject);
    procedure CheckG711UClick(Sender: TObject);
    procedure VaxSIPUserAgentOCXSuccessToRegister(Sender: TObject);
    procedure BtnHoldClick(Sender: TObject);
    procedure BtnUnholdClick(Sender: TObject);
    procedure ComboBoxRecordChange(Sender: TObject);
    procedure BtnOpenPlayWaveClick(Sender: TObject);
    procedure BtnPlayWaveStartClick(Sender: TObject);
    procedure BtnPlayWaveRewindClick(Sender: TObject);
    procedure BtnPlayWaveForwardClick(Sender: TObject);
    procedure BtnPlayWavePauseClick(Sender: TObject);
    procedure BtnPlayWaveStopClick(Sender: TObject);
    procedure BtnTransferCallClick(Sender: TObject);
    procedure TimerTickTimer(Sender: TObject);
    procedure VaxSIPUserAgentOCXCallTransferAccepted(ASender: TObject;
      LineNo: Integer);
    procedure VaxSIPUserAgentOCXConnecting(ASender: TObject;
      LineNo: Integer);
    procedure VaxSIPUserAgentOCXDisconnectCall(ASender: TObject;
      LineNo: Integer);
    
    procedure VaxSIPUserAgentOCXFailToConnect(ASender: TObject;
      LineNo: Integer);

    procedure VaxSIPUserAgentOCXGeneralFailureResponse(ASender: TObject;
      LineNo, StatusCode: Integer; const ReasonPhrase: WideString);
    procedure VaxSIPUserAgentOCXProvisionalResponse(ASender: TObject;
      LineNo, StatusCode: Integer; const ReasonPhrase: WideString);
    procedure VaxSIPUserAgentOCXRedirectionResponse(ASender: TObject;
      LineNo, StatusCode: Integer; const ReasonPhrase,
      Contact: WideString);
    procedure VaxSIPUserAgentOCXRequestFailureResponse(ASender: TObject;
      LineNo, StatusCode: Integer; const ReasonPhrase: WideString);
    procedure VaxSIPUserAgentOCXServerFailureResponse(ASender: TObject;
      LineNo, StatusCode: Integer; const ReasonPhrase: WideString);
    
    procedure VaxSIPUserAgentOCXIncomingCallRingingStart(ASender: TObject;
      const CallId: WideString);
    procedure VaxSIPUserAgentOCXIncomingCallRingingStop(ASender: TObject;
      const CallId: WideString);
    procedure VaxSIPUserAgentOCXPlayWaveDone(ASender: TObject;
      LineNo: Integer);

    procedure VaxSIPUserAgentOCXTryingToRegister(Sender: TObject);

    procedure VaxSIPUserAgentOCXTryingToUnRegister(Sender: TObject);
    procedure CheckBoxRingToneClick(Sender: TObject);
    procedure BtnMoreHelpClick(Sender: TObject);
    procedure VaxSIPUserAgentOCXDTMFDigit(ASender: TObject;
      LineNo: Integer; const Digit: WideString);
    procedure VaxSIPUserAgentOCXIncomingCall(ASender: TObject;
      const CallId, DisplayName, UserName, FromURI, ToURI: WideString);
    procedure VaxSIPUserAgentOCXSuccessToConnect(ASender: TObject;
      LineNo: Integer; const ToRTPIP: WideString; ToRTPPort: Integer);

    procedure FormCreate(Sender: TObject);
    procedure TimerProgressTimer(Sender: TObject);
    procedure VaxSIPUserAgentOCXFailToReRegister(Sender: TObject);
    procedure VaxSIPUserAgentOCXSuccessToReRegister(Sender: TObject);
    procedure VaxSIPUserAgentOCXTryingToReRegister(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

procedure TMainForm.ErrorMessages();
var
  ErrorCode : DWORD;
begin

  ErrorCode :=  VaxSIPUserAgentOCX.GetVaxObjectError();

  case ErrorCode of
     10: application.MessageBox('You are not Online, please click the ''Online'' button first.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
     11: application.MessageBox('Cann''t open local communication port.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
     12: application.MessageBox('License Key is not valid.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
     13: application.MessageBox('Fail to initialize VaxVoIP task window.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
     14: application.MessageBox('Cann''t access Input/Mic device or device is already in use.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
     15: application.MessageBox('Cann''t access Output/Speaker device or device is already in use.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
     16: application.MessageBox('Input/Mic device is not open.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
     17: application.MessageBox('Output/Speaker device is not open.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
     18: application.MessageBox('Your sound device does not support mic volume.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
     19: application.MessageBox('Your sound device does not support speaker volume.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
     20: application.MessageBox('Recording media initialization fail.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
     21: application.MessageBox('Cann''t open the wave file.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
     22: application.MessageBox('Provided SIP URI is not valid.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
     23: application.MessageBox('Codec is not supported.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
     24: application.MessageBox('Error to create SDP (Session Description Protocol) request.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
     25: application.MessageBox('Error to create CONNECTION request. Please check the provided SIP URI is valid.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
     26: application.MessageBox('Error to create REGISTER request. Please check the provided SIP URI is valid.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
     27: application.MessageBox('Error to create UN-REGISTER request. Please check the provided SIP URI is valid.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
     28: application.MessageBox('Error to create DISCONNECT request.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
     29: application.MessageBox('Line No is not valid.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
     30: application.MessageBox('Line is already busy.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
     31: application.MessageBox('Line is not open.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
     32: application.MessageBox('Invalid Call-Id.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
     33: application.MessageBox('Provided value is not valid.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
     34: application.MessageBox('Selected line is not in voice session.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
     35: application.MessageBox('Fail to read wave file.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
     36: application.MessageBox('Fail to write wave file.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
     37: application.MessageBox('Unsupported wave file format.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
     
   end;
end;

procedure TMainForm.TrackBarSpkVolChange(Sender: TObject);
begin
    {***************************************************************
     SetSpkVolume method requires Volume value from 0 to 255 range
     but the slider range is 0 to 10, so we multiply the slider value
     to 25 to get the required value to pass to SetSpkVolume method

	For more detail, please see the method details document
   *****************************************************************}

   VaxSIPUserAgentOCX.SetSpkVolume(TrackBarSpkVol.Position * 25);

end;

procedure TMainForm.TrackBarMicVolChange(Sender: TObject);
begin
     {***************************************************************
     SetMicVolume method requires Volume value from 0 to 255 range    
     but the slider range is 0 to 10, so we multiply the slider value
     to 25 to get the required value to pass to SetMicVolume method

         For more detail, please see the method details document
   *****************************************************************}

   VaxSIPUserAgentOCX.SetMicVolume(TrackBarMicVol.Position * 25);
end;

function TMainForm.InitVaxObject() : WordBool;
var
MyIP : string;
FromURI : string;
ListenPort : Integer;
RetValue : WordBool;
Begin

   {****** Constructing SIP From URI for IP Telephony *******}
   if EditDisplayName.Text = ''  then
    FromURI := EditLoginId.Text + ' <sip:' + EditLoginId.Text + '@' + EditSIPProxy.Text + '>'
   else
    FromURI := EditDisplayName.Text + ' <sip:' + EditLoginId.Text + '@' + EditSIPProxy.Text + '>';

   {********************************************************************
      Listen Port: default SIP port 5060.
        SIP Proxy: SIP Proxy IP or FQDN provided by your service provider.
    OutboundProxy: SIP outbound/NAT proxy IP or FQDN provided by your
                   service provider to use SIP phone behind the NAT.

   *********************************************************************}

   MyIP := VaxSIPUserAgentOCX.GetMyIP();

   RetValue := True;

   for ListenPort := 5060 to 7000 do
   Begin

      If False = VaxSIPUserAgentOCX.Initialize(False, MyIP, ListenPort, FromURI, EditOutBoundProxy.Text, EditSIPProxy.Text, EditLoginId.Text, EditLoginPwd.Text, CheckBoxEnableSoundDevice.Checked, StrToInt(EditTotalLines.Text)) Then
      begin
        if VaxSIPUserAgentOCX.GetVaxObjectError() <>  11 then
        begin
          ErrorMessages();
          RetValue := False;
          break;
        end
      end
      else
      begin
          break;
      end;
   end;

   If ListenPort >= 7000 Then
   begin
        application.MessageBox('Cann''t open SIP communication port.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
        RetValue := False;
   end;

  Result := RetValue;

end;

function TMainForm.OpenLines() : WordBool;
var
MyIP : string;
PortRTP : Integer;
LineNo : Integer;
RetValue : WordBool;
ErrorCount : Integer;
Begin

   MyIP := VaxSIPUserAgentOCX.GetMyIP();

   PortRTP := 7000;
   LineNo  := 0;
   ErrorCount := 0;
   RetValue := True;

   while LineNo < StrToInt(EditTotalLines.Text) do
   Begin

      If VaxSIPUserAgentOCX.OpenLine(LineNo, False, MyIP, PortRTP) = False Then
      begin

        if VaxSIPUserAgentOCX.GetVaxObjectError() =  11 then
          begin
            ErrorCount := ErrorCount + 1;
            LineNo := LineNo - 1;
          end
          else
          begin
            ErrorMessages();
            RetValue := False;
            break;
        end;

      end;

      LineNo  := LineNo + 1;
      PortRTP := PortRTP + 2;  // It is importent to increament RTP Listen Port by 2

      If ErrorCount >= (StrToInt(EditTotalLines.Text) + 1000) Then
      begin
        application.MessageBox('Unable to open RTP communication port.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
        RetValue := False;
        break;
      end;

   end;

   Result := RetValue;

end;

procedure TMainForm.UpdateListAudioIn();
var
DeviceId : Integer;
begin
     ListAudioIn.Clear();
     ListAudioIn.Items.Add('Default Device');

     for DeviceId := 0 to VaxSIPUserAgentOCX.GetAudioInDevTotal() - 1 do
     Begin
        ListAudioIn.Items.Add(VaxSIPUserAgentOCX.GetAudioInDevName(DeviceId));
     end;

     ListAudioIn.ItemIndex := 0;
end;

procedure TMainForm.UpdateListAudioOut();
var
DeviceId : Integer;
begin
     ListAudioOut.Clear();
     ListAudioOut.Items.Add('Default Device');

     for DeviceId := 0 to VaxSIPUserAgentOCX.GetAudioOutDevTotal() - 1 do
     Begin
        ListAudioOut.Items.Add(VaxSIPUserAgentOCX.GetAudioOutDevName(DeviceId));
     end;

     ListAudioOut.ItemIndex := 0;
end;

function TMainForm.GetSelectedAudioIn() : Integer;
begin
  Result := ListAudioIn.ItemIndex - 1;
end;

function TMainForm.GetSelectedAudioOut() : Integer;
begin
  Result := ListAudioOut.ItemIndex - 1;
end;

procedure TMainForm.FillComboBoxes();
var
LineNo : Integer;
begin

  ComboBoxDial.Clear();
  ComboBoxRecord.Clear();
  ComboBoxIncomingCall.Clear();
  ComboBoxPlayWave.Clear();
  ComboBoxTransferCall.Clear();

  for LineNo := 1 to StrToInt(EditTotalLines.Text) do
  begin

    ComboBoxDial.AddItem('Line-' + IntToStr(LineNo), nil);
    ComboBoxRecord.AddItem('Line-' + IntToStr(LineNo), nil);
    ComboBoxIncomingCall.AddItem('Line-' + IntToStr(LineNo), nil);
    ComboBoxPlayWave.AddItem('Line-' + IntToStr(LineNo), nil);
    ComboBoxTransferCall.AddItem('Line-' + IntToStr(LineNo), nil);

  end;

  ComboBoxDial.ItemIndex := 0;
  ComboBoxRecord.ItemIndex := 0;
  ComboBoxIncomingCall.ItemIndex := 0;
  ComboBoxPlayWave.ItemIndex := 0;
  ComboBoxTransferCall.ItemIndex := 0;

end;

procedure TMainForm.BtnInitClick(Sender: TObject);
begin

   if BtnInit.Caption = 'Offline' then
   begin
       BtnInit.Caption := 'Online';
       VaxSIPUserAgentOCX.UnInitialize();
       EditTotalLines.Enabled := True;

       TimerTick.Enabled := False;
       TimerProgress.Enabled := False;

       SpkProgBar.Position := 0;
       MicProgBar.Position := 0;

       ListAudioOut.Clear();
       ListAudioIn.Clear();
       ListViewLineStatus.Clear();
       
       exit;
   end;

   If EditLoginId.Text = '' Then
   begin
        application.MessageBox('Please enter the SIP proxy Login Id.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
        exit;
   end;

   If EditSIPProxy.Text = '' Then
   Begin
        application.MessageBox('Please enter the SIP proxy address or URI.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
        exit;
   end;

   VaxSIPUserAgentOCX.SetLicenceKey('TRIAL-LICENSE-KEY');

   if InitVaxObject() = False then exit;

   if OpenLines() = False then exit;

   if CheckBoxRegisterToProxy.Checked = True then
   begin

    If False = VaxSIPUserAgentOCX.RegisterToProxy(3600) Then
    begin
     ErrorMessages();
     exit;
    end;

    AddToStatusLog('Registering to SIP Proxy.');
  end;

  CheckEchoCancel.Checked := True;
  CheckGSM610.Checked     := True;
  CheckiLBC.Checked       := True;
  CheckG711A.Checked      := True;
  CheckG711U.Checked      := True;

  VaxSIPUserAgentOCX.EnableKeepAlive(10);

  BtnInit.Caption := 'Offline';
  ListViewLineStatus.Items.Clear();

  UpdateListAudioIn();
  UpdateListAudioOut();
  FillComboBoxes();

  EditTotalLines.Enabled := False;
  TimerTick.Enabled := True;
  TimerProgress.Enabled := True;

end;

procedure TMainForm.BtnDial1Click(Sender: TObject);
begin
  EditPhoneNo.Text := EditPhoneNo.Text + '1';
  VaxSIPUserAgentOCX.DigitDTMF(ComboBoxDial.ItemIndex, '1');
end;

procedure TMainForm.BtnDial2Click(Sender: TObject);
begin
  EditPhoneNo.Text := EditPhoneNo.Text + '2';
  VaxSIPUserAgentOCX.DigitDTMF(ComboBoxDial.ItemIndex, '2');
end;

procedure TMainForm.BtnDial3Click(Sender: TObject);
begin
  EditPhoneNo.Text := EditPhoneNo.Text + '3';
  VaxSIPUserAgentOCX.DigitDTMF(ComboBoxDial.ItemIndex, '3');
end;

procedure TMainForm.BtnDial4Click(Sender: TObject);
begin
  EditPhoneNo.Text := EditPhoneNo.Text + '4';
  VaxSIPUserAgentOCX.DigitDTMF(ComboBoxDial.ItemIndex, '4');
end;

procedure TMainForm.BtnDial5Click(Sender: TObject);
begin
  EditPhoneNo.Text := EditPhoneNo.Text + '5';
  VaxSIPUserAgentOCX.DigitDTMF(ComboBoxDial.ItemIndex, '5');
end;

procedure TMainForm.BtnDial6Click(Sender: TObject);
begin
  EditPhoneNo.Text := EditPhoneNo.Text + '6';
  VaxSIPUserAgentOCX.DigitDTMF(ComboBoxDial.ItemIndex, '6');
end;

procedure TMainForm.BtnDial7Click(Sender: TObject);
begin
  EditPhoneNo.Text := EditPhoneNo.Text + '7';
  VaxSIPUserAgentOCX.DigitDTMF(ComboBoxDial.ItemIndex, '7');
end;

procedure TMainForm.BtnDial8Click(Sender: TObject);
begin
  EditPhoneNo.Text := EditPhoneNo.Text + '8';
  VaxSIPUserAgentOCX.DigitDTMF(ComboBoxDial.ItemIndex, '8');
end;

procedure TMainForm.BtnDial9Click(Sender: TObject);
begin
  EditPhoneNo.Text := EditPhoneNo.Text + '9';
  VaxSIPUserAgentOCX.DigitDTMF(ComboBoxDial.ItemIndex, '9');
end;

procedure TMainForm.BtnDialStarClick(Sender: TObject);
begin
  VaxSIPUserAgentOCX.DigitDTMF(ComboBoxDial.ItemIndex, '*');
end;

procedure TMainForm.BtnDial0Click(Sender: TObject);
begin
  EditPhoneNo.Text := EditPhoneNo.Text + '0';
  VaxSIPUserAgentOCX.DigitDTMF(ComboBoxDial.ItemIndex, '0');
end;

procedure TMainForm.BtnDialNoClick(Sender: TObject);
begin
  VaxSIPUserAgentOCX.DigitDTMF(ComboBoxDial.ItemIndex, '#');
end;

procedure TMainForm.BtnDialClick(Sender: TObject);
var
ToURI  : string;
begin

  If EditPhoneNo.Text = '' Then
  Begin
    application.MessageBox('Please enter a phone number.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
    Exit;
  End;

  {*******************************************************
         Constructing SIP To URI for IP Telephony:
                  sip:PhoneNumber@SIP Proxy
  ********************************************************}

  ToURI := 'sip:' + EditPhoneNo.Text + '@' + EditSIPProxy.Text;

  If VaxSIPUserAgentOCX.Connect(ComboBoxDial.ItemIndex, ToURI, GetSelectedAudioIn(), GetSelectedAudioOut()) = False Then
      ErrorMessages()
  Else
      AddToStatusLog('Line-' + IntToStr(ComboBoxDial.ItemIndex + 1) + ': Dialing.');
end;

procedure TMainForm.BtnHangUpClick(Sender: TObject);
begin

   If VaxSIPUserAgentOCX.Disconnect(ComboBoxDial.ItemIndex) = False Then
       ErrorMessages();
end;

procedure TMainForm.BtnHoldClick(Sender: TObject);
begin

  If VaxSIPUserAgentOCX.HoldLine(ComboBoxDial.ItemIndex) = False Then
       ErrorMessages();
end;

procedure TMainForm.BtnUnholdClick(Sender: TObject);
begin
  If VaxSIPUserAgentOCX.UnHoldLine(ComboBoxDial.ItemIndex) = False Then
       ErrorMessages();
end;

procedure TMainForm.BtnAcceptCallClick(Sender: TObject);
var
CallId : String;
LineNo : Integer;
begin

  if ListBoxIncomingCall.ItemIndex = -1 Then
     exit;

  CallId := ListBoxIcomingCallId.Items.Strings[ListBoxIncomingCall.ItemIndex];
  LineNo := ComboBoxIncomingCall.ItemIndex;

  if VaxSIPUserAgentOCX.AcceptCall(LineNo, CallId, GetSelectedAudioIn(), GetSelectedAudioOut()) = False Then
  begin
    ErrorMessages();
    exit;
  end;

  PlaySound(nil, 0, 0);

  ListBoxIcomingCallId.Items.Delete(ListBoxIncomingCall.ItemIndex);
  ListBoxIncomingCall.Items.Delete(ListBoxIncomingCall.ItemIndex);

  if (ListBoxIncomingCall.ItemIndex = -1) and (ListBoxIncomingCall.Items.Count > 0) Then
    ListBoxIncomingCall.ItemIndex := 0;

end;

procedure TMainForm.BtnRejectCallClick(Sender: TObject);
var
CallId : String;
begin

  if ListBoxIncomingCall.ItemIndex = -1 Then
     exit;

  CallId := ListBoxIcomingCallId.Items.Strings[ListBoxIncomingCall.ItemIndex];

  if VaxSIPUserAgentOCX.RejectCall(CallId) = False Then
  begin
    ErrorMessages();
    exit;
  end;

  PlaySound(nil, 0, 0);

  ListBoxIcomingCallId.Items.Delete(ListBoxIncomingCall.ItemIndex);
  ListBoxIncomingCall.Items.Delete(ListBoxIncomingCall.ItemIndex);

  if (ListBoxIncomingCall.ItemIndex = -1) and (ListBoxIncomingCall.Items.Count > 0) Then
    ListBoxIncomingCall.ItemIndex := 0;

end;

procedure TMainForm.BtnClearClick(Sender: TObject);
begin
  ListStatusLog.Items.Clear();
end;

procedure TMainForm.BtnSaveClick(Sender: TObject);
begin

  if VaxSIPUserAgentOCX.SaveRecordingToWaveFile(ComboBoxRecord.ItemIndex, EditRecordFileName.Text) = False then
    ErrorMessages()
  else
    application.MessageBox('Saved Successfully', 'VaxVoIP SDK', MB_ICONEXCLAMATION);

end;

procedure TMainForm.CheckBoxStartRecordingClick(Sender: TObject);
begin
  if CheckBoxStartRecording.Checked = True then
    VaxSIPUserAgentOCX.StartRecording(ComboBoxRecord.ItemIndex, 2, True)
  else
    VaxSIPUserAgentOCX.StopRecording(ComboBoxRecord.ItemIndex)
end;

procedure TMainForm.BtnResetBufferClick(Sender: TObject);
begin
  VaxSIPUserAgentOCX.ResetRecording(ComboBoxRecord.ItemIndex);
end;

procedure TMainForm.ComboBoxRecordChange(Sender: TObject);
begin
     CheckBoxStartRecording.Checked := VaxSIPUserAgentOCX.IsRecording(ComboBoxRecord.ItemIndex);
end;

procedure TMainForm.CheckBoxSpkMuteClick(Sender: TObject);
begin
  VaxSIPUserAgentOCX.MuteSpk(CheckBoxSpkMute.Checked);
end;

procedure TMainForm.CheckBoxMuteMicClick(Sender: TObject);
begin
  VaxSIPUserAgentOCX.MuteMic(CheckBoxMuteMic.Checked);
end;

procedure TMainForm.VaxSIPUserAgentOCXFailToRegister(Sender: TObject);
begin
  AddToStatusLog('Fail to register.');
end;

procedure TMainForm.VaxSIPUserAgentOCXFailToUnRegister(Sender: TObject);
begin
 AddToStatusLog('Fail to un-register.');
end;

procedure TMainForm.VaxSIPUserAgentOCXSuccessToUnRegister(Sender: TObject);
begin
  AddToStatusLog('Unregistered successfully.');
end;

procedure TMainForm.CheckEchoCancelClick(Sender: TObject);
begin

  If CheckEchoCancel.Checked = True Then
    VaxSIPUserAgentOCX.EnableEchoNoiseCancellation()
  Else
    VaxSIPUserAgentOCX.DisableEchoNoiseCancellation();
  
end;

procedure TMainForm.CheckMicBoostClick(Sender: TObject);
begin
  If CheckMicBoost.Checked = True Then
    VaxSIPUserAgentOCX.EnableMicBoost()
  Else
    VaxSIPUserAgentOCX.DisableMicBoost();
end;

procedure TMainForm.CheckDonotDisturbClick(Sender: TObject);
begin
   If CheckDonotDisturb.Checked = True Then
     VaxSIPUserAgentOCX.EnableDonotDisturb()
   Else
     VaxSIPUserAgentOCX.DisableDonotDisturb();
end;

procedure TMainForm.CheckGSM610Click(Sender: TObject);
begin
  {****Codec No 0 represents GSM 6.10 *****}

  If CheckGSM610.Checked = True Then
      VaxSIPUserAgentOCX.SelectVoiceCodec(0)
  Else
      VaxSIPUserAgentOCX.DeselectVoiceCodec(0);
end;

procedure TMainForm.CheckiLBCClick(Sender: TObject);
begin
  {****Codec No 1 represents iLBC *****}

  If CheckiLBC.Checked = True Then
      VaxSIPUserAgentOCX.SelectVoiceCodec(1)
  Else
      VaxSIPUserAgentOCX.DeselectVoiceCodec(1);
end;

procedure TMainForm.CheckG711AClick(Sender: TObject);
begin
{****Codec No 2 represents iLBC *****}

  If CheckG711A.Checked = True Then
      VaxSIPUserAgentOCX.SelectVoiceCodec(2)
  Else
      VaxSIPUserAgentOCX.DeselectVoiceCodec(2);
end;

procedure TMainForm.CheckG711UClick(Sender: TObject);
begin
{****Codec No 3 represents iLBC *****}

  If CheckG711U.Checked = True Then
      VaxSIPUserAgentOCX.SelectVoiceCodec(3)
  Else
      VaxSIPUserAgentOCX.DeselectVoiceCodec(3);
end;

procedure TMainForm.VaxSIPUserAgentOCXSuccessToRegister(Sender: TObject);
begin
  AddToStatusLog('Registered successfully.');
end;

procedure TMainForm.VaxSIPUserAgentOCXTryingToRegister(Sender: TObject);
begin
  AddToStatusLog('Trying to register.');
end;

procedure TMainForm.VaxSIPUserAgentOCXTryingToUnRegister(Sender: TObject);
begin
  AddToStatusLog('Trying to un-register.');
end;

procedure TMainForm.BtnOpenPlayWaveClick(Sender: TObject);
begin

  If VaxSIPUserAgentOCX.PlayWaveOpen(ComboBoxPlayWave.ItemIndex, EditPlayFileName.Text) = False Then
      ErrorMessages();
end;

procedure TMainForm.BtnPlayWaveStartClick(Sender: TObject);
begin

  If VaxSIPUserAgentOCX.PlayWaveStart(ComboBoxPlayWave.ItemIndex, CheckBoxPlayListen.Checked) = False Then
      ErrorMessages();
      
end;

procedure TMainForm.BtnPlayWaveRewindClick(Sender: TObject);
begin

  If VaxSIPUserAgentOCX.PlayWaveSkipTo(ComboBoxPlayWave.ItemIndex, VaxSIPUserAgentOCX.PlayWavePosition(ComboBoxPlayWave.ItemIndex) - 2) = False Then
      ErrorMessages();

end;

procedure TMainForm.BtnPlayWaveForwardClick(Sender: TObject);
begin

  If VaxSIPUserAgentOCX.PlayWaveSkipTo(ComboBoxPlayWave.ItemIndex, VaxSIPUserAgentOCX.PlayWavePosition(ComboBoxPlayWave.ItemIndex) + 2) = False Then
      ErrorMessages();

end;

procedure TMainForm.BtnPlayWavePauseClick(Sender: TObject);
begin

    If VaxSIPUserAgentOCX.PlayWavePause(ComboBoxPlayWave.ItemIndex) = False Then
      ErrorMessages();

end;

procedure TMainForm.BtnPlayWaveStopClick(Sender: TObject);
begin

  If VaxSIPUserAgentOCX.PlayWaveStop(ComboBoxPlayWave.ItemIndex) = False Then
    ErrorMessages();

end;

procedure TMainForm.BtnTransferCallClick(Sender: TObject);
var ToURI : string;
begin

  ToURI := 'sip:' + EditTransferNo.Text + '@' + EditSIPProxy.Text;

  If VaxSIPUserAgentOCX.TransferCall(ComboBoxTransferCall.ItemIndex, ToURI) = False Then
      ErrorMessages();

end;

procedure TMainForm.VaxSIPUserAgentOCXCallTransferAccepted(
  ASender: TObject; LineNo: Integer);
begin
  AddToStatusLog('Line-' + IntToStr(LineNo + 1) + ': Transfer accepted.')
end;

procedure TMainForm.VaxSIPUserAgentOCXConnecting(ASender: TObject; LineNo: Integer);
begin
  AddToStatusLog('Line-' + IntToStr(LineNo + 1) + ': Connecting.');
end;

procedure TMainForm.VaxSIPUserAgentOCXDisconnectCall(ASender: TObject; LineNo: Integer);
begin
  AddToStatusLog('Line-' + IntToStr(LineNo + 1) + ': Hung up.');
end;

procedure TMainForm.VaxSIPUserAgentOCXFailToConnect(ASender: TObject;
  LineNo: Integer);
begin
  AddToStatusLog('Line-' + IntToStr(LineNo + 1) + ': Fail to connect.');
end;

procedure TMainForm.VaxSIPUserAgentOCXGeneralFailureResponse(
  ASender: TObject; LineNo, StatusCode: Integer;
  const ReasonPhrase: WideString);
begin
  AddToStatusLog('Line-' + IntToStr(LineNo + 1) + ' Response: ' + ReasonPhrase);
end;

procedure TMainForm.VaxSIPUserAgentOCXProvisionalResponse(ASender: TObject;
  LineNo, StatusCode: Integer; const ReasonPhrase: WideString);
begin
  AddToStatusLog('Line-' + IntToStr(LineNo + 1) + ' Response: ' + ReasonPhrase);
end;

procedure TMainForm.VaxSIPUserAgentOCXRedirectionResponse(ASender: TObject;
  LineNo, StatusCode: Integer; const ReasonPhrase, Contact: WideString);
begin
  AddToStatusLog('Line-' + IntToStr(LineNo + 1) + ' Response: ' + ReasonPhrase);
end;

procedure TMainForm.VaxSIPUserAgentOCXRequestFailureResponse(
  ASender: TObject; LineNo, StatusCode: Integer;
  const ReasonPhrase: WideString);
begin
    AddToStatusLog('Line-' + IntToStr(LineNo + 1) + ' Response: ' + ReasonPhrase);
end;

procedure TMainForm.VaxSIPUserAgentOCXServerFailureResponse(
  ASender: TObject; LineNo, StatusCode: Integer;
  const ReasonPhrase: WideString);
begin
  AddToStatusLog('Line-' + IntToStr(LineNo + 1) + ' Response: ' + ReasonPhrase);
end;

procedure TMainForm.VaxSIPUserAgentOCXIncomingCallRingingStart(
  ASender: TObject; const CallId: WideString);
begin

    if CheckBoxRingTone.Checked = True Then
    begin
      PlaySound('ring.wav', 0, SND_ASYNC + SND_FILENAME + SND_LOOP + SND_NODEFAULT)
    end;

end;

procedure TMainForm.VaxSIPUserAgentOCXIncomingCallRingingStop(
  ASender: TObject; const CallId: WideString);
var
ItemIndex : Integer;
begin

  ItemIndex := ListBoxIcomingCallId.Items.IndexOf(CallId);
  if ItemIndex <> -1 then
  begin
    ListBoxIcomingCallId.Items.Delete(ItemIndex);
    ListBoxIncomingCall.Items.Delete(ItemIndex);
  end;

  PlaySound(nil, 0, 0);
end;

procedure TMainForm.VaxSIPUserAgentOCXPlayWaveDone(ASender: TObject;
  LineNo: Integer);
begin
  AddToStatusLog('Line-' + IntToStr(LineNo + 1) + ': Play wave done.');
end;

procedure TMainForm.CheckBoxRingToneClick(Sender: TObject);
begin

  if CheckBoxRingTone.Checked = False Then
    PlaySound(nil, 0, 0);

end;

procedure TMainForm.BtnMoreHelpClick(Sender: TObject);
var
HelpForm : THelpForm;
begin

  HelpForm := THelpForm.Create(self);
  HelpForm.ShowModal;
  HelpForm.Free;

end;

procedure TMainForm.VaxSIPUserAgentOCXDTMFDigit(ASender: TObject;
  LineNo: Integer; const Digit: WideString);
begin
  AddToStatusLog('Line-' + IntToStr(LineNo + 1) + ': Key-pressed: ' + Digit);
end;

procedure TMainForm.VaxSIPUserAgentOCXIncomingCall(ASender: TObject;
  const CallId, DisplayName, UserName, FromURI, ToURI: WideString);
begin

  if ListBoxIcomingCallId.Items.IndexOf(CallId) = -1 then
    ListBoxIcomingCallId.Items.Add(CallId);

  if Length(DisplayName) <> 0 then
    ListBoxIncomingCall.Items.Add('CLI: ' + DisplayName)
  else
    ListBoxIncomingCall.Items.Add('CLI: ' + UserName);

  if (ListBoxIncomingCall.ItemIndex = -1) and (ListBoxIncomingCall.Items.Count > 0) Then
    ListBoxIncomingCall.ItemIndex := 0;

end;

procedure TMainForm.VaxSIPUserAgentOCXSuccessToConnect(ASender: TObject;
  LineNo: Integer; const ToRTPIP: WideString; ToRTPPort: Integer);
var
  Vol : Integer;
begin

  AddToStatusLog('Line-' + IntToStr(LineNo + 1) + ': Success to connect.');

  Vol := VaxSIPUserAgentOCX.GetSpkVolume();
  TrackBarSpkVol.Position := Vol div 25;

  Vol := VaxSIPUserAgentOCX.GetMicVolume();
  TrackBarMicVol.Position := Vol div 25;

  CheckMicBoost.Checked := VaxSIPUserAgentOCX.IsMicBoostEnable();

end;

procedure TMainForm.FormCreate(Sender: TObject);
var
Column : TListColumn;
begin
  Column := ListViewLineStatus.Columns.Add();
  Column.Caption := '#';
  Column.Width := 21;

  Column := ListViewLineStatus.Columns.Add();
  Column.Caption := 'Status';
  Column.Width := 53;

  Column := ListViewLineStatus.Columns.Add();
  Column.Caption := 'Outbound';
  Column.Width := 67;

  Column := ListViewLineStatus.Columns.Add();
  Column.Caption := 'Inbound';
  Column.Width := 64;
end;

procedure TMainForm.AddToStatusLog(LogText : String);
begin
    ListStatusLog.Items.Add(LogText);
    ListStatusLog.TopIndex := ListStatusLog.Count - 1;
end;


function TMainForm.GetCodecName(CodecNo : Integer) : String;
var
 CodecName : string;
begin

    CodecName := '';

    if CodecNo = 0 Then
        CodecName := 'gsm6.10'

    else if CodecNo = 1 Then
        CodecName := 'iLBC'

    else if CodecNo = 2 Then
        CodecName := 'gsm711a'

    else if CodecNo = 3 Then
        CodecName := 'gsm711u';

    Result := CodecName;
end;

procedure TMainForm.TimerTickTimer(Sender: TObject);
var
LineNo : Integer;
ItemText : String;
Item : TListItem;
begin

  If ListViewLineStatus.Items.Count = 0 then
  Begin

    for LineNo := 1 to StrToInt(EditTotalLines.Text) do
    begin
      Item := ListViewLineStatus.Items.Add();
      Item.Caption := IntToStr(LineNo);

      Item.SubItems.Add('');
      Item.SubItems.Add('');
      Item.SubItems.Add('');
    end;

  end;

  for LineNo := 0 to (StrToInt(EditTotalLines.Text) - 1) do
  begin

    Item := ListViewLineStatus.Items.Item[LineNo];
    ItemText := Item.SubItems.Strings[0];

    Item.SubItems.Strings[1] := GetCodecName(VaxSIPUserAgentOCX.GetOutboundCodec(LineNo));
    Item.SubItems.Strings[2] := GetCodecName(VaxSIPUserAgentOCX.GetInboundCodec(LineNo));

    If VaxSIPUserAgentOCX.IsLineOpen(LineNo) = False then
    begin

      if Pos('close', ItemText) = 0 then
        Item.SubItems.Strings[0] := 'close';

    end
    else
    begin

      If VaxSIPUserAgentOCX.IsLineBusy(LineNo) = True then
      begin

        If VaxSIPUserAgentOCX.IsWaveFilePlaying(LineNo) = True then
        begin
          if Pos('playing', ItemText) = 0 then
            Item.SubItems.Strings[0] := 'playing';
        end
        else
        begin
          if VaxSIPUserAgentOCX.IsLineHold(LineNo) = True  then
          begin
            if Pos('hold', ItemText) = 0 then
              Item.SubItems.Strings[0] := 'hold';
          end
          else
            if Pos('busy', ItemText) = 0 then
              Item.SubItems.Strings[0] := 'busy';
        end
      end
      else

        if Pos('free', ItemText) = 0 then
             Item.SubItems.Strings[0] := 'free';
    end;

  end;

end;


procedure TMainForm.TimerProgressTimer(Sender: TObject);
begin

  SpkProgBar.Position := VaxSIPUserAgentOCX.GetSpkSoundLevel();
  MicProgBar.Position := VaxSIPUserAgentOCX.GetMicSoundLevel();
  
end;

procedure TMainForm.VaxSIPUserAgentOCXFailToReRegister(Sender: TObject);
begin
  AddToStatusLog('Fail to re-register.');
end;

procedure TMainForm.VaxSIPUserAgentOCXSuccessToReRegister(Sender: TObject);
begin
  AddToStatusLog('Succcess to re-register.');
end;

procedure TMainForm.VaxSIPUserAgentOCXTryingToReRegister(Sender: TObject);
begin
  AddToStatusLog('Trying to re-register.');
end;

end.
